import IKDBBaseQuery from './IKDBBaseQuery';
import Utils from './../../API/IKUtils';
//
export default class IKDBQueryScan extends IKDBBaseQuery {
  constructor(optIndexName) {
    super(optIndexName);
  }
  async run(dbManager, appendingItems) {
    const localConsole = (dbManager.transaction ? dbManager.transaction.logger : console);
    const resp = await this.rawRun(dbManager);
    if (resp.Items) {
      let unmarshalled = Utils.decapsulateForDB(resp.Items);
      localConsole.debug('Parsed result: ', unmarshalled);
      //Check for appending items from previous query
      if (appendingItems && appendingItems.length > 0) {
        unmarshalled = unmarshalled.concat(appendingItems);
      }
      //Check for continuation
      if (resp.LastEvaluatedKey) {
        this.exclusiveStartKey = resp.LastEvaluatedKey;
        return this.run(dbManager, unmarshalled);
      } return unmarshalled;
    } return null;
  }
  async rawRun(dbManager) {
    const localConsole = (dbManager.transaction ? dbManager.transaction.logger : console);
    const query = this._rawQuery(dbManager.tableName);
    localConsole.log('Scanning: ', query);
    const resp = await dbManager.connection.scan(query).promise();
    localConsole.debug('Raw result: ', resp);
    return resp;
  }
}
